<?php
define('EmpireCMSAdmin','1');
require("../../class/connect.php");
require("../../class/db_sql.php");
require("../../class/functions.php");
$link=db_connect();
$empire=new mysqlquery();
$editor=1;
//驗證用戶
$lur=is_login();
$logininid=$lur['userid'];
$loginin=$lur['username'];
$loginrnd=$lur['rnd'];
$loginlevel=$lur['groupid'];
$loginadminstyleid=$lur['adminstyleid'];
//驗證權限
CheckLevel($logininid,$loginin,$classid,"key");

//增加關鍵字
function AddKey($keyname,$keyurl,$userid,$username){
	global $empire,$dbtbpre;
	if(!$keyname||!$keyurl)
	{printerror("EmptyKeyname","history.go(-1)");}
	//驗證權限
	CheckLevel($userid,$username,$classid,"key");
	$sql=$empire->query("insert into {$dbtbpre}enewskey(keyname,keyurl) values('".addslashes($keyname)."','".addslashes($keyurl)."');");
	$keyid=$empire->lastid();
	GetConfig();//更新緩存
	if($sql)
	{
		//操作日誌
		insert_dolog("keyid=".$keyid."<br>keyname=".$keyname);
		printerror("AddKeySuccess","key.php");
	}
	else
	{printerror("DbError","history.go(-1)");}
}

//修改關鍵字
function EditKey($keyid,$keyname,$keyurl,$userid,$username){
	global $empire,$dbtbpre;
	if(!$keyname||!$keyurl||!$keyid)
	{printerror("EmptyKeyname","history.go(-1)");}
	//驗證權限
	CheckLevel($userid,$username,$classid,"key");
	$keyid=(int)$keyid;
	$sql=$empire->query("update {$dbtbpre}enewskey set keyname='".addslashes($keyname)."',keyurl='".addslashes($keyurl)."' where keyid='$keyid'");
	GetConfig();//更新緩存
	if($sql)
	{
		//操作日誌
		insert_dolog("keyid=".$keyid."<br>keyname=".$keyname);
		printerror("EditKeySuccess","key.php");
	}
	else
	{printerror("DbError","history.go(-1)");}
}

//刪除關鍵字
function DelKey($keyid,$userid,$username){
	global $empire,$dbtbpre;
	$keyid=(int)$keyid;
	if(!$keyid)
	{printerror("NotDelKeyid","history.go(-1)");}
	//驗證權限
	CheckLevel($userid,$username,$classid,"key");
	$r=$empire->fetch1("select keyname from {$dbtbpre}enewskey where keyid='$keyid'");
	$sql=$empire->query("delete from {$dbtbpre}enewskey where keyid='$keyid'");
	GetConfig();//更新緩存
	if($sql)
	{
		//操作日誌
		insert_dolog("keyid=".$keyid."<br>keyname=".$r[keyname]);
		printerror("DelKeySuccess","key.php");
	}
	else
	{printerror("DbError","history.go(-1)");}
}

$enews=$_POST['enews'];
if(empty($enews))
{$enews=$_GET['enews'];}
//增加關鍵字
if($enews=="AddKey")
{
	$keyname=$_POST['keyname'];
	$keyurl=$_POST['keyurl'];
	AddKey($keyname,$keyurl,$logininid,$loginin);
}
//修改關鍵字
elseif($enews=="EditKey")
{
	$keyid=$_POST['keyid'];
	$keyname=$_POST['keyname'];
	$keyurl=$_POST['keyurl'];
	EditKey($keyid,$keyname,$keyurl,$logininid,$loginin);
}
//刪除關鍵字
elseif($enews=="DelKey")
{
	$keyid=$_GET['keyid'];
	DelKey($keyid,$logininid,$loginin);
}
else
{}
$sql=$empire->query("select keyid,keyname,keyurl from {$dbtbpre}enewskey order by keyid desc");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>關鍵字</title>
<link href="../adminstyle/<?=$loginadminstyleid?>/adminstyle.css" rel="stylesheet" type="text/css">
</head>

<body>
<table width="100%" border="0" align="center" cellpadding="3" cellspacing="1">
  <tr>
    <td>位置：<a href="key.php">管理內容關鍵字</a></td>
  </tr>
</table>
<form name="form1" method="post" action="key.php">
  <input type=hidden name=enews value=AddKey>
  <table width="100%" border="0" align="center" cellpadding="3" cellspacing="1" class="tableborder">
    <tr class="header">
      <td height="25">增加關鍵字:</td>
    </tr>
    <tr> 
      <td height="25" bgcolor="#FFFFFF"> 關鍵字: 
        <input name="keyname" type="text" id="keyname">
        鏈接地址:
        <input name="keyurl" type="text" id="keyurl" value="http://" size="50"> 
        <input type="submit" name="Submit" value="增加">
        <input type="reset" name="Submit2" value="重置"></td>
    </tr>
  </table>
</form>
<table width="100%" border="0" align="center" cellpadding="3" cellspacing="1" class="tableborder">
  <tr class="header"> 
    <td width="70%" height="25">關鍵字</td>
    <td width="30%" height="25"><div align="center">操作</div></td>
  </tr>
  <?
  while($r=$empire->fetch($sql))
  {
  ?>
  <form name=form2 method=post action=key.php>
  <input type=hidden name=enews value=EditKey>
  <input type=hidden name=keyid value=<?=$r[keyid]?>>
  <tr bgcolor="#FFFFFF"> 
      <td height="25">關鍵字: 
        <input name="keyname" type="text" id="keyname" value="<?=$r[keyname]?>">
      鏈接地址: 
        <input name="keyurl" type="text" id="keyurl" value="<?=$r[keyurl]?>" size="30">
    </td>
    <td height="25"><div align="center">
          <input type="submit" name="Submit3" value="修改">&nbsp;
          <input type="button" name="Submit4" value="刪除" onclick="self.location.href='key.php?enews=DelKey&keyid=<?=$r[keyid]?>';">
        </div></td>
  </tr>
  </form>
  <?
  }
  db_close();
  $empire=null;
  ?>
</table>
</body>
</html>
